/*
 * bv2 project
 * Created on Feb 14, 2005
 *
 * Copyright (C) 2005
 * Gergely Varro
 * Department of Computer Science and Information Theory
 * Budapest University of Technology and Economics
 * Budapest, Hungary
 */
package hu.bme.cs.benchmark.mutex.fujaba;

import org.apache.log4j.Logger;
import org.apache.log4j.BasicConfigurator;
import many.Container;
import many.Process;
import many.Resource;
/**
 * @author gergo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ALAP {
    private static Logger logger = Logger.getLogger(ALAP.class);
    
    public static void main(String[] args) { 
        Container c = new Container();
        Process p,p1,p2;
        Resource r;
        int N = 0;
        
        try {
            N = Integer.parseInt(args[0]);
        } catch (Exception ex) {
            System.err.println("Sample usage: java " + ALAP.class.getName() + " 5");
            System.exit(1);
        }
        
        BasicConfigurator.configure();
     
        /* Initial model generation */
        p1 = new Process();
        c.addToProcesses(p1);
        r = new Resource();
        c.addToResources(r);
        
        // held_by: r -> p1
        r.addToHeldBy(p1);
        p = p1;
        int i = 0;
        
        for(i = 1; i < N; i++) {
            p2 = new Process();
            c.addToProcesses(p2);
            r = new Resource();
            c.addToResources(r);
            // held_by: r -> p2
            r.addToHeldBy(p2);
            // next: p1 -> p2
            p1.addToNext(p2);
            p1 = p2;
        }
        // next: p1 -> p
        p1.addToNext(p);
        
        // Run tests
         try {
             if(logger.isDebugEnabled()){
                 int cnt = 0;
                 for(cnt = 0; cnt < N; cnt++) {
                     logger.debug("releaseRule: init: " + System.nanoTime());
                     c.releaseRule();
                     logger.debug("releaseRule: update: " + System.nanoTime());
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     logger.debug("giveRule: init: " + System.nanoTime());
                     c.giveRule();
                     logger.debug("giveRule: update: " + System.nanoTime());
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     logger.debug("requestSimpleRule: init: " + System.nanoTime());
                     c.requestSimpleRule();
                     logger.debug("requestSimpleRule: update: " + System.nanoTime());
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     logger.debug("takeRule: init: " + System.nanoTime());
                     c.takeRule();
                     logger.debug("takeRule: update: " + System.nanoTime());
                 }
             } else {
                 int cnt = 0;
                 for(cnt = 0; cnt < N; cnt++) {
                     c.releaseRule();
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     c.giveRule();
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     c.requestSimpleRule();
                 }
                 for(cnt = 0; cnt < N; cnt++) {
                     c.takeRule();
                 }
             }
         } catch (Exception ex) {
             System.err.println(ex.getMessage());
         }
    }
}
