/*
 * bv2 project
 * Created on Feb 14, 2005
 *
 * Copyright (C) 2005
 * Gergely Varro
 * Department of Computer Science and Information Theory
 * Budapest University of Technology and Economics
 * Budapest, Hungary
 */
package hu.bme.cs.benchmark.mutex.fujaba;

// import java.util.Date;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;
import many.Container;
import many.Process;
import many.Resource;
/**
 * @author gergo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LTS {
    private static Logger logger = Logger.getLogger(LTS.class);
    
    public static void main(String[] args) { 
        Container c = new Container();
        Process p,p1,p2;
        Resource r;
        
        int N = 0, R = 0;
        try {
            N = Integer.parseInt(args[0]);
            R = Integer.parseInt(args[1]);
        } catch (Exception ex) {
            System.err.println("Sample usage: java " + LTS.class.getName() + " 5 2");
            System.exit(1);
        }
        
        BasicConfigurator.configure();

        /* Initial model generation */
        p1 = new Process();
        c.addToProcesses(p1);
        r = new Resource();
        c.addToResources(r);
        
        // held_by: r -> p1
        r.addToHeldBy(p1);
        p = p1;
        int i = 0;
        
        for(i = 1; i < N; i++) {
            p2 = new Process();
            c.addToProcesses(p2);
            r = new Resource();
            c.addToResources(r);
            // held_by: r -> p2
            r.addToHeldBy(p2);
            // next: p1 -> p2
            p1.addToNext(p2);
            p1 = p2;
        }
        // next: p1 -> p
        p1.addToNext(p);

        // Run tests
         try {
             if(logger.isDebugEnabled()) {
                 for(int round = 0; round < R; round++) {
                     int cnt = 0;
                     for(cnt = 0; cnt < N; cnt++) {
                         logger.debug("requestStarRule: init: " + System.nanoTime());
                         c.requestStarRule();
                         logger.debug("requestStarRule: update: " + System.nanoTime());
                     }
                     logger.debug("blockedRule: init: " + System.nanoTime());
                     c.blockedRule();
                     logger.debug("blockedRule: update: " + System.nanoTime());
                     for(cnt = 0; cnt < N-1; cnt++) {
                         logger.debug("waitingRule: init: " + System.nanoTime());
                         c.waitingRule();
                         logger.debug("waitingRule: update: " + System.nanoTime());
                     }
                     logger.debug("unlockRule: init: " + System.nanoTime());
                     c.unlockRule();
                     logger.debug("unlockRule: update: " + System.nanoTime());
                     logger.debug("blockedRule: init: " + System.nanoTime());
                     c.blockedRule();
                     logger.debug("blockedRule: update: " + System.nanoTime());
                     for(cnt = 0; cnt < N-1; cnt++) {
                         // TODO What happens if a pattern cannot
                         // be matched.
                         logger.debug("waitingRule: init: " + System.nanoTime());
                         c.waitingRule();
                         logger.debug("waitingRule: update: " + System.nanoTime());
                     }
                     logger.debug("ignoreRule: init: " + System.nanoTime());
                     c.ignoreRule();
                     logger.debug("ignoreRule: update: " + System.nanoTime());
                     for(cnt = 0; cnt < N-1; cnt++) {
                         logger.debug("giveRule: init: " + System.nanoTime());
                         c.giveRule();
                         logger.debug("giveRule: update: " + System.nanoTime());
                         logger.debug("takeRule: init: " + System.nanoTime());
                         c.takeRule();
                         logger.debug("takeRule: update: " + System.nanoTime());
                         logger.debug("releaseStarRule: init: " + System.nanoTime());
                         c.releaseStarRule();
                         logger.debug("releaseStarRule: update: " + System.nanoTime());
                     }
                     logger.debug("giveRule: init: " + System.nanoTime());
                     c.giveRule();
                     logger.debug("giveRule: update: " + System.nanoTime());
                     logger.debug("takeRule: init: " + System.nanoTime());
                     c.takeRule();
                     logger.debug("takeRule: update: " + System.nanoTime());
                 } 
             } else {
                 for(int round = 0; round < R; round++) {
                     int cnt = 0;
                     for(cnt = 0; cnt < N; cnt++) {
                         c.requestStarRule();
                     }
                     c.blockedRule();
                     for(cnt = 0; cnt < N-1; cnt++) {
                         c.waitingRule();
                     }
                     c.unlockRule();
                     c.blockedRule();
                     for(cnt = 0; cnt < N-1; cnt++) {
                         // TODO How the generated method indicates that
                         // the pattern cannot be matched?
                         c.waitingRule();
                     }
                     c.ignoreRule();
                     for(cnt = 0; cnt < N-1; cnt++) {
                         c.giveRule();
                         c.takeRule();
                         c.releaseStarRule();
                     }
                     c.giveRule();
                     c.takeRule();
                 } 
             }
         } catch (Exception ex) {
             System.err.println(ex.getMessage());
         }
    }
}
